<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="用户id" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入用户id" />
      </el-form-item>
      <el-form-item label="需求开始日期" prop="reqStartDate">
        <el-date-picker
          v-model="formData.reqStartDate"
          type="date"
          value-format="x"
          placeholder="选择需求开始日期"
        />
      </el-form-item>
      <el-form-item label="需求结束日期" prop="reqEndDate">
        <el-date-picker
          v-model="formData.reqEndDate"
          type="date"
          value-format="x"
          placeholder="选择需求结束日期"
        />
      </el-form-item>
      <el-form-item label="工资上限" prop="upSalary">
        <el-input v-model="formData.upSalary" placeholder="请输入工资上限" />
      </el-form-item>
      <el-form-item label="工资下限" prop="downSalary">
        <el-input v-model="formData.downSalary" placeholder="请输入工资下限" />
      </el-form-item>
      <el-form-item label="允许联系" prop="allowConnect">
        <el-radio-group v-model="formData.allowConnect">
          <el-radio label="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="是否为单胎" prop="isSingleBaby">
        <el-radio-group v-model="formData.isSingleBaby">
          <el-radio label="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="上户区域" prop="workArea">
        <el-input v-model="formData.workArea" placeholder="请输入上户区域" />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
      <el-form-item label="需求状态5=已过期 4=已完成 3=上户中 2=已接单 1=已发布 0=未发布" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio label="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="是否为急单" prop="isRushReq">
        <el-radio-group v-model="formData.isRushReq">
          <el-radio label="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="上户周期" prop="reqCycle">
        <el-input v-model="formData.reqCycle" placeholder="请输入上户周期" />
      </el-form-item>
      <el-form-item label="区域id" prop="areaId">
        <el-input v-model="formData.areaId" placeholder="请输入区域id" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as RequestApi from '@/api/request'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  userId: undefined,
  reqStartDate: undefined,
  reqEndDate: undefined,
  upSalary: undefined,
  downSalary: undefined,
  allowConnect: undefined,
  isSingleBaby: undefined,
  workArea: undefined,
  remark: undefined,
  status: undefined,
  isRushReq: undefined,
  reqCycle: undefined,
  areaId: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await RequestApi.getRequest(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as RequestApi.RequestVO
    if (formType.value === 'create') {
      await RequestApi.createRequest(data)
      message.success(t('common.createSuccess'))
    } else {
      await RequestApi.updateRequest(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    userId: undefined,
    reqStartDate: undefined,
    reqEndDate: undefined,
    upSalary: undefined,
    downSalary: undefined,
    allowConnect: undefined,
    isSingleBaby: undefined,
    workArea: undefined,
    remark: undefined,
    status: undefined,
    isRushReq: undefined,
    reqCycle: undefined,
    areaId: undefined
  }
  formRef.value?.resetFields()
}
</script>
